//  Per-pixel Blinn-Phong lighting
//  Vertex shader

varying vec3 Half;
varying vec3 Light;
varying vec3 Normal;
varying vec2 TexPos;
varying vec4 Ambient;
   
void main()
{
   //
   //  Lighting values needed by fragment shader
   //
   //  Vertex location in modelview coordinates
   vec3 P = vec3(gl_ModelViewMatrix * gl_Vertex);
   //  Light position
   Light  = vec3(gl_LightSource[0].position) - P;
   //  Normal
   Normal = gl_NormalMatrix * gl_Normal;
   //  Half vector
   Half  = gl_LightSource[0].halfVector.xyz;
   //  Ambient color
   Ambient = gl_FrontMaterial.emission + gl_FrontLightProduct[0].ambient + gl_LightModel.ambient*gl_FrontMaterial.ambient;

   //  Texture coordinate for fragment shader
   TexPos = gl_MultiTexCoord0.st;

   //  Set vertex position
   gl_Position = ftransform();
}
